
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

// *****************************************************************************
// Archivo: Asistencia.cpp
// Descripcin: Clase Asistencia (cdigo)
// Autor: Ezequiel Gastn Miravalles
// ltima modificacin: 28/07/2009
// Website: http://www.neoegm.com/
// *****************************************************************************

#include "Asistencia.h"
#include <iostream>

using std::ostream;
using std::endl;

ostream& operator<<(ostream& oStream, Asistencia& raAsistencia)
{
	oStream << "Hora: " << raAsistencia.HoraEvento() << endl;
	oStream << "Tipo: " << raAsistencia.TipoTexto() << endl;
	oStream << "Justificacin: " << raAsistencia.Justificacion() << endl;

	return oStream;
}

const char * Asistencia::TipoTexto()
{
	switch (m_nTipo)
	{
	case Asistencia_Tipo_Ingreso:
		return "Ingreso";
	case Asistencia_Tipo_Salida:
		return "Salida";
	case Asistencia_Tipo_Almuerzo_Salida:
		return "Salida a almorzar";
	case Asistencia_Tipo_Almuerzo_Entrada:
		return "Vuelta de almorzar";
	default:
		return "";
	}
}
