
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

// *****************************************************************************
// Archivo: Persona.h
// Descripcin: Clase Persona (header)
// Autor: Ezequiel Gastn Miravalles
// ltima modificacin: 28/07/2009
// Website: http://www.neoegm.com/
// *****************************************************************************

#pragma once

#include "PersonaBasica.h"

#include "Lista.h"
#include "Asistencia.h"

class Persona : public PersonaBasica
{
	String m_sPassword;

	bool m_bAdmin;

	Lista<Asistencia> m_lAsistencia;

public:
	//Construccin
	Persona() { m_bAdmin = false; }

	//Encapsulaciones
	String Password() const { return "********"; }
	void Password(String val) { m_sPassword = val; }

	bool Admin() const { return m_bAdmin; }
	void Admin(bool val) { m_bAdmin = val; }

	int CantidadEventos() { return m_lAsistencia.Cantidad(); }

	bool AgregarEvento(Asistencia& aAsistencia) { return m_lAsistencia.Agregar(aAsistencia) != -1; }
	
	bool CompararPassword(String sPassword) { return sPassword == m_sPassword; }

	Lista<Asistencia>& ListaAsistencia() { return m_lAsistencia; }
};

std::ostream& operator<<(std::ostream& oStream, Persona pPersona);
