
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

// *****************************************************************************
// Archivo: String.h
// Descripcin: Clase String (header)
// Autor: Ezequiel Gastn Miravalles
// ltima modificacin: 28/07/2009
// Website: http://www.neoegm.com/
// *****************************************************************************

#pragma once

#include <iostream>
#include <cstring>

class String
{
	char *m_pszString;
	int m_nAllocated;
	
public:
	//Construccin y destruccin
	String() { m_pszString = NULL; m_nAllocated = 0; }
	~String() { if (m_pszString) delete [] m_pszString; }

	//Constructores de copia
	String(const char *pszString) { m_pszString = NULL; m_nAllocated = 0; operator=(pszString); }
	String(const String& rsString) { m_pszString = NULL; m_nAllocated = 0; operator=(rsString); }

	//Operadores
	String& operator=(const char *pszString);
	String& operator=(const String& rsString) { return operator=(rsString.m_pszString); }

	String& operator+=(const char *pszString);
	String& operator+=(String& rsString) { return operator+=(rsString.m_pszString); }
	String operator+(String rsString);

	bool operator==(String sString) { return strcmp(operator const char*(), (const char*)sString) == 0; }

	//Operadores de conversin
	operator const char*() { return m_pszString?m_pszString:""; }

	//Informacin
	int Largo() { return m_pszString?strlen(m_pszString):0; }
	
	//Operaciones
	void Vaciar();

protected:
	bool Realocar(int nSize);
};

//Output e input
std::ostream& operator<<(std::ostream& oStream, String& rsString);
std::istream& operator>>(std::istream& iStream, String& rsString);
