
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

//---------------------------------------------------------------------------
//
// Name:        wxAdministracionDlg.cpp
// Author:      NeoEGM
// Created:     29/06/2009 7:54:03 PM
// Description: wxAdministracionDlg class implementation
//
//---------------------------------------------------------------------------

#include "wxAdministracionDlg.h"
#include "wxAltaUsuarioDlg.h"
#include "wxListaUsuariosTextDlg.h"
#include "wxListaUsuariosDlg.h"

#include <fstream>
using std::ofstream;

#include <sstream>
using std::stringstream;

#include <string>
using std::string;

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// wxAdministracionDlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(wxAdministracionDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(wxAdministracionDlg::OnClose)
	EVT_BUTTON(ID_WXBUTTON5,wxAdministracionDlg::WxButton5Click)
	EVT_BUTTON(ID_WXBUTTON4,wxAdministracionDlg::WxButton4Click)
	EVT_BUTTON(ID_WXBUTTON6,wxAdministracionDlg::WxButton6Click)
	EVT_BUTTON(ID_WXBUTTON3,wxAdministracionDlg::WxButton3Click)
	EVT_BUTTON(ID_WXBUTTON7,wxAdministracionDlg::WxButton7Click)
	EVT_BUTTON(ID_WXBUTTON2,wxAdministracionDlg::WxButton2Click)
	EVT_BUTTON(ID_WXBUTTON1,wxAdministracionDlg::WxButton1Click)
END_EVENT_TABLE()
////Event Table End

wxAdministracionDlg::wxAdministracionDlg(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	m_pctMain = NULL;
	CreateGUIControls();
}

wxAdministracionDlg::~wxAdministracionDlg()
{
} 

void wxAdministracionDlg::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxBoxSizer1 = new wxBoxSizer(wxHORIZONTAL);
	this->SetSizer(WxBoxSizer1);
	this->SetAutoLayout(true);

	WxBoxSizer2 = new wxBoxSizer(wxVERTICAL);
	WxBoxSizer1->Add(WxBoxSizer2, 1, wxALIGN_CENTER | wxALL, 5);

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("       "), wxPoint(279,5), wxDefaultSize, 0, wxT("WxStaticText1"));
	WxStaticText1->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxStaticText1,1,wxALIGN_CENTER | wxALL,5);

	WxUsername = new wxStaticText(this, ID_WXUSERNAME, wxT("Usuario: \"XXXXXX\""), wxPoint(194,67), wxDefaultSize, 0, wxT("WxUsername"));
	WxUsername->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxUsername,0,wxALIGN_CENTER | wxALL,20);

	WxButton1 = new wxButton(this, ID_WXBUTTON1, wxT("Alta de usuario..."), wxPoint(5,129), wxSize(608,41), 0, wxDefaultValidator, wxT("WxButton1"));
	WxButton1->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxButton1,0,wxALIGN_CENTER | wxALL,5);

	WxButton2 = new wxButton(this, ID_WXBUTTON2, wxT("Lista de usuarios (datos adquiridos)... [Opcin 1]"), wxPoint(5,180), wxSize(608,41), 0, wxDefaultValidator, wxT("WxButton2"));
	WxButton2->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxButton2,0,wxALIGN_CENTER | wxALL,5);

	WxButton7 = new wxButton(this, ID_WXBUTTON7, wxT("Lista de usuarios (datos adquiridos)... [Opcin 2]"), wxPoint(5,231), wxSize(608,41), 0, wxDefaultValidator, wxT("WxButton7"));
	WxButton7->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxButton7,0,wxALIGN_CENTER | wxALL,5);

	WxButton3 = new wxButton(this, ID_WXBUTTON3, wxT("Salida a archivo... [Opcin 1]"), wxPoint(5,282), wxSize(608,41), 0, wxDefaultValidator, wxT("WxButton3"));
	WxButton3->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxButton3,0,wxALIGN_CENTER | wxALL,5);

	WxButton6 = new wxButton(this, ID_WXBUTTON6, wxT("Salida a archivo... [Opcin 2]"), wxPoint(5,333), wxSize(608,41), 0, wxDefaultValidator, wxT("WxButton6"));
	WxButton6->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxButton6,0,wxALIGN_CENTER | wxALL,5);

	WxButton4 = new wxButton(this, ID_WXBUTTON4, wxT("Cerrar la aplicacin"), wxPoint(5,384), wxSize(608,41), 0, wxDefaultValidator, wxT("WxButton4"));
	WxButton4->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxButton4,0,wxALIGN_CENTER | wxALL,5);

	WxButton5 = new wxButton(this, ID_WXBUTTON5, wxT("Volver a la pantalla principal"), wxPoint(5,435), wxSize(608,41), 0, wxDefaultValidator, wxT("WxButton5"));
	WxButton5->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxButton5,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT("      "), wxPoint(283,486), wxDefaultSize, 0, wxT("WxStaticText2"));
	WxStaticText2->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxStaticText2,1,wxALIGN_CENTER | wxALL,5);

	SetTitle(wxT("Sistema de control de asistencia de personal (ADMINISTRACIN)"));
	SetIcon(wxNullIcon);
	
	GetSizer()->Layout();
	GetSizer()->Fit(this);
	GetSizer()->SetSizeHints(this);
	Center();
	
	////GUI Items Creation End
	
	Maximize();
}

void wxAdministracionDlg::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}

/*
 * WxButton5Click
 */
void wxAdministracionDlg::WxButton5Click(wxCommandEvent& event)	//Volver a la pantalla principal
{
	EndModal(wxCANCEL);
}

/*
 * WxButton4Click
 */
void wxAdministracionDlg::WxButton4Click(wxCommandEvent& event)	//Cerrar la aplicacin
{
	if (wxMessageBox("Est seguro de que desea cerrar la aplicacin?", "Sistema de control de asistencia de personal", wxYES_NO) == wxYES)
		EndModal(wxOK);
}

/*
 * WxButton1Click
 */
void wxAdministracionDlg::WxButton1Click(wxCommandEvent& event)	//Alta de usuario
{
	wxAltaUsuarioDlg dlgAlta(this);
	
	if (dlgAlta.ShowModal() == wxOK)
	{
		if (m_pctMain)
		{
			m_pctMain->AgregarPersona(dlgAlta.m_pPersona);
			wxMessageBox("Persona agregada satisfactoriamente");
		}
	}
}

void wxAdministracionDlg::SaveFile(wxString sFile)
{
	//Creo objeto de la clase ofstream (Output File Stream)
	ofstream fFile;

	//Abro archivo ubicado en el path obtenido (se abre con write access por ser ofstream)
	fFile.open(sFile.c_str());

	if (fFile.fail())	//Si no se pudo abrir
		wxMessageBox("Error al intentar abrir el archivo especificado", wxMessageBoxCaptionStr, wxOK | wxICON_EXCLAMATION);
	else
	{
		fFile << m_pctMain->ListaPersonas();
		wxMessageBox("Archivo guardado satisfactoriamente");
	}
}

/*
 * WxButton3Click
 */
void wxAdministracionDlg::WxButton3Click(wxCommandEvent& event)		//Salida a archivo (opcin 1)
{
	wxTextEntryDialog dialog(this, "Ruta del archivo de destino (ej: \"C:\\Asistencia.txt\" o \"Asistencia.txt\"", "Archivo de destino", "Asistencia.txt", wxOK | wxCANCEL);

    if (dialog.ShowModal() == wxID_OK)
        SaveFile(dialog.GetValue());
}

/*
 * WxButton6Click
 */
void wxAdministracionDlg::WxButton6Click(wxCommandEvent& event)		//Salida a archivo (opcin 2)
{
	wxFileDialog dialog(this, "Archivo de destino", wxEmptyString, _T("Asistencia.txt"), _T("Archivos de texto (*.txt)|*.txt"), wxFD_SAVE|wxFD_OVERWRITE_PROMPT);
	
	if (dialog.ShowModal() == wxID_OK)
		SaveFile(dialog.GetPath());
}

/*
 * WxButton2Click
 */
void wxAdministracionDlg::WxButton2Click(wxCommandEvent& event)		//Lista de usuarios (opcin 1)
{
	stringstream sStream;
	
	//wxMessageBox(wxString::Format("%d", m_pctMain->CantidadDePersonas()));

	sStream << m_pctMain->ListaPersonas();
	
	wxListaUsuariosTextDlg dlgLista(this);
	dlgLista.GetTextBox()->SetValue(sStream.str().c_str());

	dlgLista.ShowModal();
}

/*
 * WxButton7Click
 */
void wxAdministracionDlg::WxButton7Click(wxCommandEvent& event)		//Lista de usuarios (opcin 2)
{
	wxListaUsuariosDlg dlgLista(this);
	
	dlgLista.SetControlAsistencia(m_pctMain);
	
	dlgLista.ShowModal();
}
