
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

//---------------------------------------------------------------------------
//
// Name:        wxAdministracionDlg.h
// Author:      NeoEGM
// Created:     29/06/2009 7:54:03 PM
// Description: wxAdministracionDlg class declaration
//
//---------------------------------------------------------------------------

#ifndef __WXADMINISTRACIONDLG_h__
#define __WXADMINISTRACIONDLG_h__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/button.h>
#include <wx/stattext.h>
#include <wx/sizer.h>
////Header Include End

#include "ControlDeAsistencia.h"

////Dialog Style Start
#undef wxAdministracionDlg_STYLE
#define wxAdministracionDlg_STYLE wxCAPTION | wxSTAY_ON_TOP | wxCLOSE_BOX
////Dialog Style End

class wxAdministracionDlg : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		wxAdministracionDlg(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("Sistema de control de asistencia de personal (ADMINISTRACIN)"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxAdministracionDlg_STYLE);
		virtual ~wxAdministracionDlg();
		void WxButton5Click(wxCommandEvent& event);
		void WxButton4Click(wxCommandEvent& event);
		
		void SetUsername(wxString sString) { WxUsername->SetLabel("Usuario: \"" + sString + "\""); }
		void WxButton1Click(wxCommandEvent& event);
		
		void SetControlAsistencia(ControlDeAsistencia *pctMain) { m_pctMain = pctMain; }
		void WxButton3Click(wxCommandEvent& event);
		void WxButton6Click(wxCommandEvent& event);
		void WxButton2Click(wxCommandEvent& event);
		void WxButton7Click(wxCommandEvent& event);
	
	private:
		//Do not add custom control declarations between 
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxStaticText *WxStaticText2;
		wxButton *WxButton5;
		wxButton *WxButton4;
		wxButton *WxButton6;
		wxButton *WxButton3;
		wxButton *WxButton7;
		wxButton *WxButton2;
		wxButton *WxButton1;
		wxStaticText *WxUsername;
		wxStaticText *WxStaticText1;
		wxBoxSizer *WxBoxSizer2;
		wxBoxSizer *WxBoxSizer1;
		////GUI Control Declaration End
		
		ControlDeAsistencia *m_pctMain;
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_WXSTATICTEXT2 = 1031,
			ID_WXBUTTON5 = 1029,
			ID_WXBUTTON4 = 1028,
			ID_WXBUTTON6 = 1034,
			ID_WXBUTTON3 = 1027,
			ID_WXBUTTON7 = 1035,
			ID_WXBUTTON2 = 1026,
			ID_WXBUTTON1 = 1025,
			ID_WXUSERNAME = 1033,
			ID_WXSTATICTEXT1 = 1009,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
	
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
		void SaveFile(wxString sFile);
};

#endif
