
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

//---------------------------------------------------------------------------
//
// Name:        wxAltaUsuarioDlg.cpp
// Author:      NeoEGM
// Created:     29/06/2009 8:27:24 PM
// Description: wxAltaUsuarioDlg class implementation
//
//---------------------------------------------------------------------------

#include "wxAltaUsuarioDlg.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// wxAltaUsuarioDlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(wxAltaUsuarioDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(wxAltaUsuarioDlg::OnClose)
	EVT_BUTTON(ID_WXCANCELAR,wxAltaUsuarioDlg::WxCancelarClick)
	EVT_BUTTON(ID_WXACEPTAR,wxAltaUsuarioDlg::WxAceptarClick)
END_EVENT_TABLE()
////Event Table End

wxAltaUsuarioDlg::wxAltaUsuarioDlg(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

wxAltaUsuarioDlg::~wxAltaUsuarioDlg()
{
} 

void wxAltaUsuarioDlg::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxBoxSizer1 = new wxBoxSizer(wxHORIZONTAL);
	this->SetSizer(WxBoxSizer1);
	this->SetAutoLayout(true);

	WxBoxSizer2 = new wxBoxSizer(wxVERTICAL);
	WxBoxSizer1->Add(WxBoxSizer2, 1, wxALIGN_CENTER | wxEXPAND | wxALL, 5);

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT(""), wxPoint(273,5), wxDefaultSize, 0, wxT("WxStaticText2"));
	WxStaticText2->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxStaticText2,1,wxALIGN_CENTER | wxALL,5);

	WxBoxSizer3 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer2->Add(WxBoxSizer3, 0, wxALIGN_CENTER | wxALL, 0);

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("DNI"), wxPoint(5,5), wxSize(220, 37), wxST_NO_AUTORESIZE, wxT("WxStaticText1"));
	WxStaticText1->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer3->Add(WxStaticText1,0,wxALIGN_CENTER | wxALL,5);

	WxDNI = new wxTextCtrl(this, ID_WXDNI, wxT(""), wxPoint(235,6), wxSize(311,35), 0, wxDefaultValidator, wxT("WxDNI"));
	WxDNI->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer3->Add(WxDNI,0,wxALIGN_CENTER | wxALL,5);

	WxBoxSizer4 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer2->Add(WxBoxSizer4, 0, wxALIGN_CENTER | wxALL, 0);

	WxStaticText4 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("Nombre Completo"), wxPoint(5,5), wxSize(220, 37), wxST_NO_AUTORESIZE, wxT("WxStaticText4"));
	WxStaticText4->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer4->Add(WxStaticText4,0,wxALIGN_CENTER | wxALL,5);

	WxNombre = new wxTextCtrl(this, ID_WXEDIT1, wxT(""), wxPoint(235,6), wxSize(311,35), 0, wxDefaultValidator, wxT("WxNombre"));
	WxNombre->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer4->Add(WxNombre,0,wxALIGN_CENTER | wxALL,5);

	WxBoxSizer5 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer2->Add(WxBoxSizer5, 0, wxALIGN_CENTER | wxALL, 0);

	WxStaticText5 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("Password"), wxPoint(5,5), wxSize(220, 37), wxST_NO_AUTORESIZE, wxT("WxStaticText5"));
	WxStaticText5->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer5->Add(WxStaticText5,0,wxALIGN_CENTER | wxALL,5);

	WxPassword = new wxTextCtrl(this, ID_WXEDIT1, wxT(""), wxPoint(235,6), wxSize(311,35), wxTE_PASSWORD, wxDefaultValidator, wxT("WxPassword"));
	WxPassword->SetBackgroundColour(wxColour(245,237,175));
	WxPassword->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer5->Add(WxPassword,0,wxALIGN_CENTER | wxALL,5);

	WxBoxSizer6 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer2->Add(WxBoxSizer6, 0, wxALIGN_LEFT | wxALL, 5);

	WxAdmin = new wxCheckBox(this, ID_WXADMIN, wxT("Administrador"), wxPoint(0,10), wxSize(192,27), 0, wxDefaultValidator, wxT("WxAdmin"));
	WxAdmin->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer6->Add(WxAdmin,1,wxALIGN_LEFT | wxTOP,10);

	WxBoxSizer7 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer2->Add(WxBoxSizer7, 0, wxALIGN_CENTER | wxTOP, 30);

	WxAceptar = new wxButton(this, ID_WXACEPTAR, wxT("Aceptar"), wxPoint(5,5), wxSize(118,73), 0, wxDefaultValidator, wxT("WxAceptar"));
	WxAceptar->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer7->Add(WxAceptar,0,wxALIGN_CENTER | wxALL,5);

	WxCancelar = new wxButton(this, ID_WXCANCELAR, wxT("Cancelar"), wxPoint(133,5), wxSize(118,73), 0, wxDefaultValidator, wxT("WxCancelar"));
	WxCancelar->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer7->Add(WxCancelar,0,wxALIGN_CENTER | wxALL,5);

	WxStaticText3 = new wxStaticText(this, ID_WXSTATICTEXT3, wxT(""), wxPoint(273,320), wxDefaultSize, 0, wxT("WxStaticText3"));
	WxStaticText3->SetFont(wxFont(20, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	WxBoxSizer2->Add(WxStaticText3,1,wxALIGN_CENTER | wxALL,5);

	SetTitle(wxT("Alta de usuario"));
	SetIcon(wxNullIcon);
	
	GetSizer()->Layout();
	GetSizer()->Fit(this);
	GetSizer()->SetSizeHints(this);
	Center();
	
	WxAceptar->SetDefault();
	
	////GUI Items Creation End
}

void wxAltaUsuarioDlg::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}

/*
 * WxCancelarClick
 */
void wxAltaUsuarioDlg::WxCancelarClick(wxCommandEvent& event)
{
	EndDialog(wxCANCEL);
}

/*
 * WxAceptarClick
 */
void wxAltaUsuarioDlg::WxAceptarClick(wxCommandEvent& event)
{
	if (!WxDNI->GetValue().Len() || !WxNombre->GetValue().Len() || !WxPassword->GetValue().Len())
	{
		wxMessageBox("Debe completar todos los campos", wxMessageBoxCaptionStr, wxOK | wxICON_EXCLAMATION);
		return;	
	}
	
	long nDNI;
	WxDNI->GetValue().ToLong(&nDNI);
	
	m_pPersona.DNI(nDNI);
	m_pPersona.NombreCompleto(WxNombre->GetValue().c_str());
	m_pPersona.Password(WxPassword->GetValue().c_str());
	m_pPersona.Admin(WxAdmin->IsChecked());
	
	EndDialog(wxOK);
}
