
/*************************************************************************************************
This file is part of wxControlAsistencia

Copyright (C) 2009 Ezequiel Gastn Miravalles

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************************************/

/*************************************************************************************************
Software: wxControlAsistencia
Author: Ezequiel Gastn Miravalles
Website: http://www.neoegm.com/es/tech/programming/c-cpp/wxwidgets/wx-control-de-asistencia/
License: GNU GPL v3 (attached, read above)
*************************************************************************************************/

//---------------------------------------------------------------------------
//
// Name:        wxListaUsuariosDlg.h
// Author:      NeoEGM
// Created:     30/06/2009 1:32:45 AM
// Description: wxListaUsuariosDlg class declaration
//
//---------------------------------------------------------------------------

#ifndef __WXLISTAUSUARIOSDLG_h__
#define __WXLISTAUSUARIOSDLG_h__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/button.h>
#include <wx/listctrl.h>
#include <wx/stattext.h>
#include <wx/sizer.h>
////Header Include End

#include "ControlDeAsistencia.h"

////Dialog Style Start
#undef wxListaUsuariosDlg_STYLE
#define wxListaUsuariosDlg_STYLE wxCAPTION | wxSTAY_ON_TOP | wxCLOSE_BOX
////Dialog Style End

class wxListaUsuariosDlg : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		wxListaUsuariosDlg(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("Lista de usuarios"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxListaUsuariosDlg_STYLE);
		virtual ~wxListaUsuariosDlg();
		
		void SetControlAsistencia(ControlDeAsistencia *pctMain) { m_pctMain = pctMain; }
		void WxButton1Click(wxCommandEvent& event);
		void wxListaUsuariosDlgInitDialog(wxInitDialogEvent& event);
		void WxListCtrl1Selected(wxListEvent& event);
		void WxListCtrl1Deselected(wxListEvent& event);
	
	private:
		//Do not add custom control declarations between 
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxButton *WxButton1;
		wxListCtrl *WxListCtrl2;
		wxStaticText *WxStaticText2;
		wxListCtrl *WxListCtrl1;
		wxStaticText *WxStaticText1;
		wxBoxSizer *WxBoxSizer1;
		////GUI Control Declaration End
		
		ControlDeAsistencia *m_pctMain;
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_WXBUTTON1 = 1006,
			ID_WXLISTCTRL2 = 1005,
			ID_WXSTATICTEXT2 = 1004,
			ID_WXLISTCTRL1 = 1003,
			ID_WXSTATICTEXT1 = 1002,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
	
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
		void CargarUsuarios();
		void RefrescarListaAsistencia(int nPersonaItem);
		
		void ResizeColumns(wxListCtrl* pListCtrl);
};

#endif
